Bug 96679 - Need UNO commands for all font effects
Summary: Need UNO commands for all font effects
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsDevEval
Depends on:
Blocks: UNO-Command-New
  Show dependency treegraph
 
Reported: 2015-12-23 05:01 UTC by Joel Madero
Modified: 2017-06-30 16:25 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Joel Madero 2015-12-23 05:01:21 UTC
Bodhi Moksha
Version: 5.2.0.0.alpha0+
Build ID: 5df326438fd3a5613a52b4de1935426911ff1301

To see all font effects:
1) alt + o;
2) c (or h depending on your version of LibreOffice)
3) Select Font Effects tab

Many of these are not available to assign shortcuts but it would be really useful to have an easy way to assign a shortcut to each of these options.

Requesting UX advise here as I think it might be somewhat tricky to do (for instance, if you assign a shortcut to strikethrough....what type of strikethrough is applied)

Thanks UX in advance.
Comment 1 Joel Madero 2015-12-23 05:27:59 UTC
To add additional input here:
options might include:
*small caps
*all caps
*title
*title
*Outline
*Shadow
*Blinking
*Hidden
*Embossed
*Engraved

etc...
Comment 2 Cor Nouws 2015-12-23 13:19:19 UTC
Hi Joel,

I'm a bit biased on this idea.
- People can already use character styles and assign short cuts to those.
- Short cuts for font effect via direct formatting, is ... eh direct formatting.
But I won't object of course if a nice solution with available short cuts is found.
Comment 3 Joel Madero 2015-12-23 17:22:01 UTC
> I'm a bit biased on this idea.
> - People can already use character styles and assign short cuts to those.
> - Short cuts for font effect via direct formatting, is ... eh direct
> formatting.

Of course I feel generally the same :) But if we allow shortcuts for bold/italics/superscript/subscript/etc......seems strange to have an arbitrary barrier just to try to force styles.

Anyways - wasn't actually my idea. It came from another bug report and I think generally I've given up hope that the average day to day user is ever going to get comfortable with using styles consistently (at least how they are now).

But yeah, I agree that in an ideal world styles would be the go to. Thanks for the feedback.
Comment 4 Heiko Tietze 2015-12-27 10:01:36 UTC
I support Cor's argument. The most relevant formattings are available, adding more shortcuts by default is difficult since we run out of keys, individual customization is possible and, in general, we want to promote styles. 
-> WORKSFORME
Comment 5 Cor Nouws 2015-12-27 15:25:23 UTC
(In reply to Joel Madero from comment #3)

> Anyways - wasn't actually my idea. It came from another bug report and ...

If the other report- reporter has a clear and balanced proposal, of course he/she is more then welcome to report that here.
Cheers - Cor
Comment 6 Joel Madero 2015-12-28 16:48:04 UTC
Fair enough - I pointed to this bug from the other bug report and they can add what they want.

Anyways, I'm done proposing enhancements for UI/UX - I don't understand the philosophy. Generally speaking before QA had a VERY low bar for enhancement requests - basically the principle was:

1) Would it help some users;
2) Would it hurt the project in some way;

We tried to actively engage with users to encourage them to give ideas - to flush those ideas out, and to explain that many enhancements will never be implemented (they depend on someone actually caring enough to implement) but that we're happy to leave them open in case someone does find them interesting enough to implement.

Now, it appears like UX has some golden key to some secret room with little (if any) guide as to what is allowed in and what isn't. This proposal met the above criteria (some users would find it useful, having a few extra keyboard shortcuts available as an *option* surely wouldn't impact anyone else's work) yet it was rejected based on "well they could do it another way" or "they *should* use styles"

Anyways, I'm no fan of this method of a few "insiders" having some arbitrary way of closing enhancement requests so I'll stop reporting them.

Thanks for taking the time to close this one as WFM.

P.S. The idea wasn't to set more as default - it was to allow users to add them themselves in the keyboard shortcuts options.

Removing myself from CC - no need to explain anything to me.
Comment 7 Michael Meeks 2016-01-01 14:18:35 UTC
Hi guys; so - tentatively re-opening this; Heiko - thanks for your feedback, let me comment on that:

> The most relevant formattings are available,

agreed.

> adding more shortcuts by default is difficult since we run out of keys, 

agreed - and it makes people type these things by mistake ;-)

> individual customization is possible and

This is the piece I think you missed; so - if I want to configure a key to do one of the things that Joel mentions eg. 'Embossed' or 'small caps' - how can I do that ?

A superficial scan of tools->customize->keyboard suggests that this is very far from trivial. It is perhaps possible for experts to write macros for those - but I'd (personally) struggle to do that myself ;-) so ...

As such, I suspect that this enhancement comes down to creating and translating a new set of UNO commands to apply those effects; much as I like styles - I think that's a reasonably valid request - surely ?
Comment 8 Heiko Tietze 2016-01-01 19:55:32 UTC
It's possible to configure your own shortcut right now: Start customize from main menu, switch to tab keyboard, select the target key like shift+strl+s, select your function below (category=format, function=strikethrough) and click modify to assign the selected shortcut to this function (not sure that every direct formatting has a pendant there since emboss wasn't there on the first glance).

Admittedly, it's not easy to configure (here is an old blog post how we could improve this dialog, althogh I would change some aspects today: http://user-prompt.com/de/how-to-make-libreoffice-customization-usable/). And in the course of implementing the extended toolbar we need a better customization anyway.

What Cor and me challenge is the idea to assign a fix shortcut. But that's only two opinions, against three voting pro such a feature (out of >120M; and I understand your point as actually 50/50). Anyway, if the yea-sayers outweight the sceptical people I'm fine with any change.
Comment 9 Cor Nouws 2016-01-02 21:25:00 UTC
Hi,

As I wrote: it is possible already now.
But indeed, you need to perform two steps: create a character style and assign that to a short cut. (Macro's linked to a short cut would work too.)
I think for someone making heavily use of these settings that would be doable?

Nevertheless, when I closed this as WorksForMe, I wrote (implicitly) that I'm willing to look at further proposals. It might of course be that I missed something.
Looking at comment #1 and the Format>Character menu in 5.1.x, one can see that Outline and Shadow are already available.
So I'm always a great fan of asking people enough explanation and examples, use cases before setting something to new. There are enough orphan issues and ideas probably. So I don't like to award half baken ideas with a enhancement status. 
Apologies if that might be to strict :)


Of course the idea to create separate UNO commands - if needed - for additional font effects would make it easier for people to assign shortcuts.
Recording a simple macro to set the effect Embossed, shows uno:CharacterRelief. 
So maybe all effects are already available?

If the user that came up with the wish could be so kind to check that, it would be helpful.

Changing summary from "Add Ability to Assign Keyboard Shortcuts for All Font Effects" to "Need UNO commands for all font effects"

Since there are questions, I set this to NeedInfo for now.
Comment 10 Jan Holesovsky 2016-01-04 14:26:23 UTC
Michael: Not sure it is worth adding uno commands; if I understand it correctly, it would be enough to have a button that would effectively mean "create a character style from the currently chosen font effect" in the Font Effects tab - that would at the same time allow assigning the shortcut (as the character styles can have that).

That would be possible to implement without big changes I suspect.

Joel: Is that something you had in mind?  Or am I completely misunderstanding? :-)
Comment 11 Joel Madero 2016-01-04 15:01:23 UTC
(In reply to Jan Holesovsky from comment #10)
> Michael: Not sure it is worth adding uno commands; if I understand it
> correctly, it would be enough to have a button that would effectively mean
> "create a character style from the currently chosen font effect" in the Font
> Effects tab - that would at the same time allow assigning the shortcut (as
> the character styles can have that).
> 
> That would be possible to implement without big changes I suspect.
> 
> Joel: Is that something you had in mind?  Or am I completely
> misunderstanding? :-)

Well the big issue is the forcing the idea of "use styles or don't have the feature." Many people don't understand (and never will understand) the idea of styles. Just to be clear, this wasn't my idea to begin with - I wish I could find the original bug report but it was someone talking about accessibility with keyboard shortcuts and how tedious it is to apply some font effects but so easy to apply others (bold, underline, etc...). 

I see that this would resolve the issue but would require some understanding of how styles work and how to assign a keyboard shortcut to a style. Do you think the avg. user would understand that they could go to the Font Effects dialog and click a button that says "create style our of currently selected . . ." and then they would know that once they do that they could assign a keyboard shortcut to it? This vs. just going into the keyboard shortcut list (that already lists hundreds of things), quickly seeing "embossed" or "strikethrough" and being able to assign a shortcut to it (if they so desire).

Just seems to me that we have an arbitrary list of what made the cut vs. what didn't to keyboard shortcuts (for example, why is double underline justified as an effect worthy of a keyboard shortcut, while strikethrough, embossed, engraved, all caps, title, etc.... are not?) The request by the user (again...I wish I could find the original report :-/) was just to make it a complete list instead of an arbitrary list.
Comment 12 Jan Holesovsky 2016-01-04 15:33:29 UTC
Joel: I meant, the underlying logic could be hidden to the user, for me it's important to understand the use case - if it is good enough if it appears as a character style in the document, of if it is important that it is direct formatting.  At the same time, I hope it is the former - because the usability of styles is an orthogonal problem.

How the original cut came to existence, I have no idea.  I suspect it is a mixture of interoperability & what is available as formatting in the ODF / OOXML etc.  We could measure that on a corpus of documents at some stage, and see if there are some particularly interesting use cases there that would be worth adding shortcuts for.
Comment 13 Joel Madero 2016-01-04 15:41:20 UTC
(In reply to Jan Holesovsky from comment #12)
> Joel: I meant, the underlying logic could be hidden to the user, for me it's
> important to understand the use case - if it is good enough if it appears as
> a character style in the document, of if it is important that it is direct
> formatting.  At the same time, I hope it is the former - because the
> usability of styles is an orthogonal problem.

Sure - so I obviously will leave implementation discussion to UX. If you think that this could accomplish the same thing in a better way way, of course you're the expert :)

Just to be abundantly clear, I'm not asking for a pet bug to be *implemented*, I'm happy to see the discussion and at least acknowledging that the status quo makes it hard for users who want quick and efficient access to quite a few effects (hard relative to how easy it is to apply other styles such as double underline, bold, etc...)

So if your proposal makes sense in light of this (this mostly goes over my head), then why not just mark as NEW and let it sit as NEW until a volunteer decides to take it on (which might be never or might be next week :) )

> 
> How the original cut came to existence, I have no idea.  I suspect it is a
> mixture of interoperability & what is available as formatting in the ODF /
> OOXML etc.  We could measure that on a corpus of documents at some stage,
> and see if there are some particularly interesting use cases there that
> would be worth adding shortcuts for.

:-D As so many other things, the "how did it happen this way" is hard to determine :)
Comment 14 Cor Nouws 2016-01-04 16:39:17 UTC
(In reply to Joel Madero from comment #13)

> Just to be abundantly clear, I'm not asking for a pet bug to be
> *implemented*, I'm happy to see the discussion and at least acknowledging
> that the status quo makes it hard for users who want quick and efficient
> access to quite a few effects (hard relative to how easy it is to apply
> other styles such as double underline, bold, etc...)

Just asking attention for the fact that (in addition to comment 9 ) it is extremely helpful if people with wishes themselves contribute to have up to date and clear information. Thanks!
Comment 15 Cor Nouws 2016-01-04 16:52:06 UTC
Hi Kendy,

(In reply to Jan Holesovsky from comment #10)
> Michael: Not sure it is worth adding uno commands; if I understand it
> correctly, it would be enough to have a button that would effectively mean
> "create a character style from the currently chosen font effect" in the Font
> Effects tab - that would at the same time allow assigning the shortcut (as
> the character styles can have that).

Fine for me.

When doing this, then it's only one step away to add a control "Assign short cut" to the Organizer tab of a Character/Paragraph/Frame style's Dialog. 
(An existing wish, but as far as I can see not yet ported from OOo to LibreOffice bugzilla).
(And so that would potentially open a (UI) conflict ;) )
Comment 16 Cor Nouws 2016-01-04 16:53:42 UTC
component LibreOffice since this is nice for Calc too (Impress/Draw doesn't yet support character styles (see bug 40871)
Comment 17 Yousuf Philips (jay) (retired) 2017-06-30 16:25:47 UTC
(In reply to Michael Meeks from comment #7)
> As such, I suspect that this enhancement comes down to creating and
> translating a new set of UNO commands to apply those effects; much as I like
> styles - I think that's a reasonably valid request - surely ?

Yes this is what the enhancement should achieve.

(In reply to Jan Holesovsky from comment #10)
> Michael: Not sure it is worth adding uno commands; if I understand it
> correctly, it would be enough to have a button that would effectively mean
> "create a character style from the currently chosen font effect" in the Font
> Effects tab - that would at the same time allow assigning the shortcut (as
> the character styles can have that).

Cluttering up the character dialog with such a feature is bad UX and having UNO commands for features only available in the dialog is highly beneficial, as then they can be used in many places, as and when needed.

(In reply to Joel Madero from comment #1)
> *small caps

UNO command present - .uno:SmallCaps

> *all caps
> *title
> *lowercase

We have UNO commands that provide this same behaviour but they work on the actual text and dont toggle the font effect entry (.uno:ChangeCaseToUpper, .uno:ChangeCaseToTitleCase, .uno:ChangeCaseToLower).

> *Outline

UNO command present - .uno:OutlineFont

> *Shadow

UNO command present - .uno:Shadowed

> *Blinking
> *Hidden
> *Embossed
> *Engraved

These UNO commands need to be created.